//// "@(#)$RCSfile: sdi_transaction.hxx,v $ $Revision: 1.5 $ $AVS$ $Date: 1998/03/09 13:17:11 $"
//
//		Copyright (c) 1994 by
//		Advanced Visual Systems Inc.
//		All Rights Reserved
//	
//	This software comprises unpublished confidential information of
//	Advanced Visual Systems Inc. and may not be used, copied or made
//	available to anyone, except in accordance with the license
//	under which it is furnished.
//	
//      This file is under Perforce control
//      $Id: //depot/express/dbproj/dbil/sdi_transaction.hxx#1 $
//


// file: sdi_transaction.hxx
// author: Patrick Li, Advanced Visual Systems
// purpose: Define SDI_Transaction class
//
#ifndef SDI_TRANSACTION_DEFINED
#define SDI_TRANSACTION_DEFINED 1

#include "avs/dbil.h"
#include "sdi_error.hxx"

class SDI_Connection;

// Define SDI_Transaction class
//
class SDI_Transaction : public SDI_Error_Tool {
public:
   enum transaction_states { Closed, Open };

   SDI_Transaction();
   virtual ~SDI_Transaction();

   // Set and get connection information for this transaction
   //
   void SetConnection( SDI_Connection *connect );
   SDI_Connection *GetConnection() const { return connection; }

   // Start a transaction on the specified connection
   //
   SDI_Status SetState( transaction_states new_state );

   // Commit or rollback the current transaction
   //
   SDI_Status Commit();
   SDI_Status Rollback();

   // Set and get transaction parameters
   //
   void SetAutoRollback( int flag );
   int GetAutoRollback() { return auto_rollback; }

private:
   transaction_states state;

   int auto_rollback;
   SDI_Connection *connection;

   // Create private copy constructor and assignment operator 
   // to invalidate copys and assignments
   //
   SDI_Transaction( const SDI_Transaction & ) {}
   SDI_Transaction &operator=(const SDI_Transaction &) { return *this; }
};
#endif
